unit UFormMain;

{$mode delphi}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, Menus,
  ExtCtrls, UEngine, LCLType, types;

type

  { TFormMain }

  TFormMain = class(TForm)
    PaintBox1: TPaintBox;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: char);
    procedure FormShow(Sender: TObject);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox1MouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure PaintBox1MouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure PaintBox1Paint(Sender: TObject);
    procedure PaintBox1Resize(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  public
    Engine: TEngine;
    procedure EraseBackground(DC: HDC); override;
  end;

var
  FormMain: TFormMain;

implementation

{$R *.lfm}

uses
  UFormImages;

{ TFormMain }

procedure TFormMain.FormCreate(Sender: TObject);
begin
  Engine := TEngine.Create;
  //PaintBox1.ControlStyle := [csOpaque];
end;

procedure TFormMain.FormDestroy(Sender: TObject);
begin
  Engine.Free;
end;

procedure TFormMain.FormKeyPress(Sender: TObject; var Key: char);
begin
  if (Key = #32) then begin
    if Engine.State = gsRunning then Engine.State := gsPaused
    else if Engine.State = gsPaused then Engine.State := gsRunning;
  end;
end;

procedure TFormMain.FormShow(Sender: TObject);
begin
  Randomize;
  Engine.ImagePassenger.Picture.Assign(FormImages.ImagePassenger.Picture);
  Engine.ImageLocomotive.Picture.Assign(FormImages.ImageLocomotive.Picture);
  Engine.Map.Size := Point(PaintBox1.Width, PaintBox1.Height);
  Engine.View.DestRect := Rect(0, 0, PaintBox1.Width, PaintBox1.Height);
  Engine.Reset;
end;

procedure TFormMain.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Engine.MouseDown(Button, Point(X, Y));
end;

procedure TFormMain.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  Engine.MouseMove(Point(X, Y));
end;

procedure TFormMain.PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Engine.MouseUp(Button, Point(X, Y));
end;

procedure TFormMain.PaintBox1MouseWheelDown(Sender: TObject;
  Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
begin
  Engine.View.Zoom := Engine.View.Zoom / 1.2;
end;

procedure TFormMain.PaintBox1MouseWheelUp(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
  Engine.View.Zoom := Engine.View.Zoom * 1.2;
end;

procedure TFormMain.PaintBox1Paint(Sender: TObject);
begin
  Engine.View.DestRect := Rect(0, 0, PaintBox1.Width, PaintBox1.Height);
  Engine.Paint(PaintBox1.Canvas);
end;

procedure TFormMain.PaintBox1Resize(Sender: TObject);
begin
  Engine.Redraw;
end;

procedure TFormMain.Timer1Timer(Sender: TObject);
begin
  Engine.Tick;
  if Engine.RedrawPending then
    PaintBox1.Repaint;
end;

procedure TFormMain.EraseBackground(DC: HDC);
begin
  // Do nothing, all background space covered by controls
end;

end.

